/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */		
const YesNoNode = require( '../YesNoNode' );
const Q_which_summon = require( './Q_which_summon' );
const BattleCalc = require( '../../BattleCalc' );
const UseAbility = require( '../UseAbility' );

const Q_ally_low_mana = function( actor, battleState ) {
	const node = new YesNoNode( actor, battleState );
	
	node.sendMana = BattleCalc.getEquippedAbility( actor,'send_mana' );

	node.branches[ node.NO ] = new Q_which_summon( actor, battleState );
			
	if( node.sendMana ) {
		node.branches[ node.YES ] = new UseAbility( actor, 'send_mana' );
	} else {
		node.branches[ node.YES ] = node.branches[ node.NO ];
	}

	node.getLowMPAlly = function() {
		var lowMPAlly = null;
		var allies = this.battleState.getAlliesOfUnit( this.actor );

		for( var i = 0; i < allies; ++i ) {
			var ally = allies[ i ];
			if( ally.mp/ally.max_mp < 0.4 )	{
				return ally;					
			}
		}
			
		return null;
	};	
	
	node.query = function()	{
		if( this.sendMana ) {
			var lowMPAlly = this.getLowMPAlly();
			if( lowMPAlly ) {
				return this.branches[this.YES].query( lowMPAlly );
			} else {
				return this.branches[this.NO].query();
			}
		} else {
			return this.branches[this.NO].query();
		}
	};	

	return node;	
};
module.exports = Q_ally_low_mana
