const HexTile = require('./HexTile');
const DoorsFactory = require('./DoorsFactory');
const PortalFactory = require('./PortalFactory');
const StairsFactory = require('./StairsFactory');
const WallsFactory = require('./WallsFactory');

const RectangleRoom = function(entrance='SOUTH', exits=['NORTH','EAST','WEST'], cavernsLevel=1, columns=10, rows=10) {
  const tiles = [];
  let x, y;

  for (x = 0; x < columns; x += 2) {
    for (y = 1; y < rows; y += 2) {
      tiles.push(HexTile(x,y));
    }
  }

  for (x = 1; x < columns; x += 2) {
    for (y = 0; y < rows; y += 2) {
      tiles.push(HexTile(x,y));
    }
  }

  const doors = DoorsFactory(tiles,entrance,exits).concat(
    StairsFactory(tiles, entrance, cavernsLevel, 2),
  );

  return {
    tiles,
    doors,
    walls: WallsFactory(tiles, doors),
    portal: cavernsLevel > 1 && PortalFactory(tiles),
  };
};
module.exports = RectangleRoom;
