const ItemGenerator = require('../../../game_items/ItemGenerator.js');
var MedTorsoe = require('../../../game_items/equipment/torsoe/MedTorsoe.js');
var MedBoots = require('../../../game_items/equipment/boots/MedBoots.js');
var Dagger = require('../../../game_items/equipment/weapon/Dagger.js');
var Bow = require('../../../game_items/equipment/off_hand/Bow.js');
const getMobEquipmenAssignmentFromBags = require('./getMobEquipmenAssignmentFromBags');

const bandit = (level) => {
  const handle = 'bandit';
  const AI_PRIORITIES = ['interference', 'dps_ranged', 'dps_close', 'tank', 'support'];

  const bags = [{
    items: [
      ItemGenerator.getRandomItem(MedTorsoe, 0, Math.min(1,0.1+level/100)),
      ItemGenerator.getRandomItem(MedBoots, 0, Math.min(1,0.1+level/100)),
      ItemGenerator.getRandomItem(Dagger, 0, Math.min(1,0.1+level/100)),
      ItemGenerator.getRandomItem(Bow, 0, Math.min(1,0.1+level/100)),
    ],
  }];

  return {
    handle,
    level,
    getAbilityTrees: ((bound_level) => ([{
      handle: 'bandit_abilities',
      abilities: {
        move: { handle: 'move', level: 1 },
        melee_attack: { handle: 'melee_attack', level: 1 },
        arrow_shot: { handle: 'arrow_shot', level: Math.min(10,Math.round(1+bound_level/2)) },
        leg_shot: { handle: 'leg_shot', level: Math.min(10,Math.round(1+bound_level/2)) },
        range: { handle: 'range', level: Math.min(10,Math.round(1+bound_level/2)) },
      },
    }])).bind(null, level),
    getBaseAttributes: ((bound_level) => ({
      learning: Math.round(1.2 + bound_level*0.35 + Math.random()*3),
      perception: Math.round(2.2 + bound_level*0.65 + Math.random()*3),
      mana: Math.round(1.1 + bound_level*0.3 + Math.random()*3),
      toughness: Math.round(1.7 + bound_level*0.45 + Math.random()*3),
      strength: Math.round(1.8 + bound_level*0.5 + Math.random()*3),
      willpower: Math.round(1.1 + bound_level*0.3 + Math.random()*3),
      dexterity: Math.round(2.1 + bound_level*0.65 + Math.random()*3),
    })).bind(null, level),
    getDefaultAIConfig: () => AI_PRIORITIES,
    xpValue: level * 350,
    bags,
    build: {
      ai: {
        priorities: AI_PRIORITIES,
        settings: {
          chanceToSkipRoles: true,
          autoMove: true,
          waitForAPMP: false,
        },
      },
      ai_unit: true,
      beast: false,
      equipment_assignment: getMobEquipmenAssignmentFromBags(bags),
      equipped_abilities: ['move', 'melee_attack', 'arrow_shot', 'leg_shot', 'range'],
      handle,
      humanoid: true,
      level,
      team: 'black',
      undead: false,
      unit: true,
    },
  };
};
module.exports = bandit;
