'use strict'

const { getMongoDBClient } = require('../index')

const getLeaderboardEntries = async ({ playerId, matchType, locationFilter={} }) => {
  const { db } = await getMongoDBClient()

  const query = {}
  const { country_code, city } = locationFilter
  if (country_code) {
    query.COUNTRY_CODE = country_code
  } else if (city) {
    query.MY_CITY = city
  }

  const res = await db.collection(`${matchType}-leaderboard`)
    .find(query)
    .sort({ NEW_RATING: -1 })
    .limit(100)
    .toArray()

  // TODO(@rob-wfs): maybe check if the player is in the results (i.e. top 100), and if not, grab & append their entry 

  return res
}
module.exports = getLeaderboardEntries
